=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class AccessPoliciesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # List access policys
    # ViewSet for AccessPolicy.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :customized 
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :viewset_name Filter results where viewset_name matches value
    # @option opts [String] :viewset_name__contains Filter results where viewset_name contains value
    # @option opts [String] :viewset_name__icontains Filter results where viewset_name contains value
    # @option opts [Array<String>] :viewset_name__in Filter results where viewset_name is in a comma-separated list of values
    # @option opts [String] :viewset_name__startswith Filter results where viewset_name starts with value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedAccessPolicyResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List access policys
    # ViewSet for AccessPolicy.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :customized 
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :viewset_name Filter results where viewset_name matches value
    # @option opts [String] :viewset_name__contains Filter results where viewset_name contains value
    # @option opts [String] :viewset_name__icontains Filter results where viewset_name contains value
    # @option opts [Array<String>] :viewset_name__in Filter results where viewset_name is in a comma-separated list of values
    # @option opts [String] :viewset_name__startswith Filter results where viewset_name starts with value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedAccessPolicyResponseList, Integer, Hash)>] PaginatedAccessPolicyResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AccessPoliciesApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/access_policies/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'customized'] = opts[:'customized'] if !opts[:'customized'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'viewset_name'] = opts[:'viewset_name'] if !opts[:'viewset_name'].nil?
      query_params[:'viewset_name__contains'] = opts[:'viewset_name__contains'] if !opts[:'viewset_name__contains'].nil?
      query_params[:'viewset_name__icontains'] = opts[:'viewset_name__icontains'] if !opts[:'viewset_name__icontains'].nil?
      query_params[:'viewset_name__in'] = @api_client.build_collection_param(opts[:'viewset_name__in'], :csv) if !opts[:'viewset_name__in'].nil?
      query_params[:'viewset_name__startswith'] = opts[:'viewset_name__startswith'] if !opts[:'viewset_name__startswith'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedAccessPolicyResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AccessPoliciesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an access policy
    # ViewSet for AccessPolicy.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param access_policy_href [String] 
    # @param patched_access_policy [PatchedAccessPolicy] 
    # @param [Hash] opts the optional parameters
    # @return [AccessPolicyResponse]
    def partial_update(access_policy_href, patched_access_policy, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(access_policy_href, patched_access_policy, opts)
      data
    end

    # Update an access policy
    # ViewSet for AccessPolicy.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param access_policy_href [String] 
    # @param patched_access_policy [PatchedAccessPolicy] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AccessPolicyResponse, Integer, Hash)>] AccessPolicyResponse data, response status code and response headers
    def partial_update_with_http_info(access_policy_href, patched_access_policy, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AccessPoliciesApi.partial_update ...'
      end
      # verify the required parameter 'access_policy_href' is set
      if @api_client.config.client_side_validation && access_policy_href.nil?
        fail ArgumentError, "Missing the required parameter 'access_policy_href' when calling AccessPoliciesApi.partial_update"
      end
      # verify the required parameter 'patched_access_policy' is set
      if @api_client.config.client_side_validation && patched_access_policy.nil?
        fail ArgumentError, "Missing the required parameter 'patched_access_policy' when calling AccessPoliciesApi.partial_update"
      end
      # resource path
      local_var_path = '{access_policy_href}'.sub('{' + 'access_policy_href' + '}', CGI.escape(access_policy_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patched_access_policy) 

      # return_type
      return_type = opts[:return_type] || 'AccessPolicyResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AccessPoliciesApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an access policy
    # ViewSet for AccessPolicy.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param access_policy_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [AccessPolicyResponse]
    def read(access_policy_href, opts = {})
      data, _status_code, _headers = read_with_http_info(access_policy_href, opts)
      data
    end

    # Inspect an access policy
    # ViewSet for AccessPolicy.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param access_policy_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(AccessPolicyResponse, Integer, Hash)>] AccessPolicyResponse data, response status code and response headers
    def read_with_http_info(access_policy_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AccessPoliciesApi.read ...'
      end
      # verify the required parameter 'access_policy_href' is set
      if @api_client.config.client_side_validation && access_policy_href.nil?
        fail ArgumentError, "Missing the required parameter 'access_policy_href' when calling AccessPoliciesApi.read"
      end
      # resource path
      local_var_path = '{access_policy_href}'.sub('{' + 'access_policy_href' + '}', CGI.escape(access_policy_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AccessPolicyResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AccessPoliciesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an access policy
    # ViewSet for AccessPolicy.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param access_policy_href [String] 
    # @param access_policy [AccessPolicy] 
    # @param [Hash] opts the optional parameters
    # @return [AccessPolicyResponse]
    def update(access_policy_href, access_policy, opts = {})
      data, _status_code, _headers = update_with_http_info(access_policy_href, access_policy, opts)
      data
    end

    # Update an access policy
    # ViewSet for AccessPolicy.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param access_policy_href [String] 
    # @param access_policy [AccessPolicy] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AccessPolicyResponse, Integer, Hash)>] AccessPolicyResponse data, response status code and response headers
    def update_with_http_info(access_policy_href, access_policy, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AccessPoliciesApi.update ...'
      end
      # verify the required parameter 'access_policy_href' is set
      if @api_client.config.client_side_validation && access_policy_href.nil?
        fail ArgumentError, "Missing the required parameter 'access_policy_href' when calling AccessPoliciesApi.update"
      end
      # verify the required parameter 'access_policy' is set
      if @api_client.config.client_side_validation && access_policy.nil?
        fail ArgumentError, "Missing the required parameter 'access_policy' when calling AccessPoliciesApi.update"
      end
      # resource path
      local_var_path = '{access_policy_href}'.sub('{' + 'access_policy_href' + '}', CGI.escape(access_policy_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(access_policy) 

      # return_type
      return_type = opts[:return_type] || 'AccessPolicyResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AccessPoliciesApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
