=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class ImportersPulpImportsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a pulp import
    # Trigger an asynchronous task to import a Pulp export.
    # @param pulp_importer_href [String] 
    # @param pulp_import [PulpImport] 
    # @param [Hash] opts the optional parameters
    # @return [TaskGroupOperationResponse]
    def create(pulp_importer_href, pulp_import, opts = {})
      data, _status_code, _headers = create_with_http_info(pulp_importer_href, pulp_import, opts)
      data
    end

    # Create a pulp import
    # Trigger an asynchronous task to import a Pulp export.
    # @param pulp_importer_href [String] 
    # @param pulp_import [PulpImport] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TaskGroupOperationResponse, Integer, Hash)>] TaskGroupOperationResponse data, response status code and response headers
    def create_with_http_info(pulp_importer_href, pulp_import, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImportersPulpImportsApi.create ...'
      end
      # verify the required parameter 'pulp_importer_href' is set
      if @api_client.config.client_side_validation && pulp_importer_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_importer_href' when calling ImportersPulpImportsApi.create"
      end
      # verify the required parameter 'pulp_import' is set
      if @api_client.config.client_side_validation && pulp_import.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_import' when calling ImportersPulpImportsApi.create"
      end
      # resource path
      local_var_path = '{pulp_importer_href}imports/'.sub('{' + 'pulp_importer_href' + '}', CGI.escape(pulp_importer_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(pulp_import) 

      # return_type
      return_type = opts[:return_type] || 'TaskGroupOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImportersPulpImportsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a pulp import
    # ViewSet for PulpImports.
    # @param pulp_pulp_import_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(pulp_pulp_import_href, opts = {})
      delete_with_http_info(pulp_pulp_import_href, opts)
      nil
    end

    # Delete a pulp import
    # ViewSet for PulpImports.
    # @param pulp_pulp_import_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(pulp_pulp_import_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImportersPulpImportsApi.delete ...'
      end
      # verify the required parameter 'pulp_pulp_import_href' is set
      if @api_client.config.client_side_validation && pulp_pulp_import_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_pulp_import_href' when calling ImportersPulpImportsApi.delete"
      end
      # resource path
      local_var_path = '{pulp_pulp_import_href}'.sub('{' + 'pulp_pulp_import_href' + '}', CGI.escape(pulp_pulp_import_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImportersPulpImportsApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List pulp imports
    # ViewSet for PulpImports.
    # @param pulp_importer_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedImportResponseList]
    def list(pulp_importer_href, opts = {})
      data, _status_code, _headers = list_with_http_info(pulp_importer_href, opts)
      data
    end

    # List pulp imports
    # ViewSet for PulpImports.
    # @param pulp_importer_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedImportResponseList, Integer, Hash)>] PaginatedImportResponseList data, response status code and response headers
    def list_with_http_info(pulp_importer_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImportersPulpImportsApi.list ...'
      end
      # verify the required parameter 'pulp_importer_href' is set
      if @api_client.config.client_side_validation && pulp_importer_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_importer_href' when calling ImportersPulpImportsApi.list"
      end
      # resource path
      local_var_path = '{pulp_importer_href}imports/'.sub('{' + 'pulp_importer_href' + '}', CGI.escape(pulp_importer_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedImportResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImportersPulpImportsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a pulp import
    # ViewSet for PulpImports.
    # @param pulp_pulp_import_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ImportResponse]
    def read(pulp_pulp_import_href, opts = {})
      data, _status_code, _headers = read_with_http_info(pulp_pulp_import_href, opts)
      data
    end

    # Inspect a pulp import
    # ViewSet for PulpImports.
    # @param pulp_pulp_import_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ImportResponse, Integer, Hash)>] ImportResponse data, response status code and response headers
    def read_with_http_info(pulp_pulp_import_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImportersPulpImportsApi.read ...'
      end
      # verify the required parameter 'pulp_pulp_import_href' is set
      if @api_client.config.client_side_validation && pulp_pulp_import_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_pulp_import_href' when calling ImportersPulpImportsApi.read"
      end
      # resource path
      local_var_path = '{pulp_pulp_import_href}'.sub('{' + 'pulp_pulp_import_href' + '}', CGI.escape(pulp_pulp_import_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ImportResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImportersPulpImportsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
